<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex43.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex43.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex43.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex43.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 43: Basic Object-Oriented Analysis and Design</h1>
                <p>I'm going to describe a process to use when you want to build something using Python, specifically with object-oriented programming (OOP).  What I mean by a &quot;process&quot; is that I'll give you a set of steps that you do in order, but that you aren't meant to be a slave to or that will totally always work for every problem.  They are just a good starting point for many programming problems and shouldn't be considered the <em>only</em> way to solve these types of problems.  This process is just one way to do it that you can follow.</p>
<p>The process is as follows:</p>
<ol class="arabic simple">
<li>Write or draw about the problem.</li>
<li>Extract key concepts from 1 and research them.</li>
<li>Create a class hierarchy and object map for the concepts.</li>
<li>Code the classes and a test to run them.</li>
<li>Repeat and refine.</li>
</ol>
<p>The way to look at this process is that it is &quot;top down,&quot; meaning it starts from the very abstract loose idea and then slowly refines it until the idea is solid and something you can code.</p>
<p>I start by just writing about the problem and trying to think up anything I can about it.  Maybe I'll even draw a diagram or two, maybe a map of some kind, or even write myself a series of emails describing the problem.  This gives me a way to express the key concepts in the problem and also explore what I might already know about it.</p>
<p>Then I go through these notes, drawings, and descriptions and I pull out the key concepts.  There's a simple trick to doing this:  Simply make a list of all the <em>nouns</em> and <em>verbs</em> in your writing and drawings, then write out how they're related.  This gives me a good list of names for classes, objects, and functions in the next step.  I take this list of concepts and then research any that I don't understand so I can refine them further if I needed.</p>
<p>Once I have my list of concepts I create a simple outline/tree of the concepts and how they are related as classes.  You can usually take your list of nouns and start asking &quot;Is this one like other concept nouns? That means they have a common parent class, so what is it called?&quot; Keep doing this until you have a class hierarchy that's just a simple tree list or a diagram.  Then take the <em>verbs</em> you have and see if those are function names for each class and put them in your tree.</p>
<p>With this class hierarchy figured out, I sit down and write some basic skeleton code that has just the classes, their functions, and nothing more.  I then write a test that runs this code and makes sure the classes I've made make sense and work right.  Sometimes I may write the test first though, and other times I might write a little test, a little code, a little test, etc. until I have the whole thing built.</p>
<p>Finally, I keep cycling over this process repeating it and refining as I go and making it as clear as I can before doing more implementation.  If I get stuck at any particular part because of a concept or problem I haven't anticipated, then I sit down and start the process over on just that part to figure it out more before continuing.</p>
<p>I will now go through this process while coming up with a game engine and a game for this exercise.</p>
<div class="section" id="the-analysis-of-a-simple-game-engine">
<h1>The Analysis of a Simple Game Engine</h1>
<p>The game I want to make is called &quot;Gothons from Planet Percal #25&quot; and will be a small space adventure game. With nothing more than that concept in my mind I can explore the idea and figure out how to make the game come to life.</p>
<div class="section" id="write-or-draw-about-the-problem">
<h2>Write or Draw About the Problem</h2>
<p>I'm going to write a little paragraph for the game:</p>
<p>&quot;Aliens have invaded a space ship and our hero has to go through a maze of rooms defeating them so he can escape into an escape pod to the planet below.  The game will be more like a Zork or Adventure type game with text outputs and funny ways to die.  The game will involve an engine that runs a map full of rooms or scenes.  Each room will print its own description when the player enters it and then tell the engine what room to run next out of the map.&quot;</p>
<p>At this point I have a good idea for the game and how it would run, so now I want to describe each scene:</p>
<dl class="docutils">
<dt>Death</dt>
<dd>This is when the player dies and should be something funny.</dd>
<dt>Central Corridor</dt>
<dd>This is the starting point and has a Gothon already standing there they have to defeat with a joke before continuing.</dd>
<dt>Laser Weapon Armory</dt>
<dd>This is where the hero gets a neutron bomb to blow up the ship before getting to the escape pod. It has a keypad the hero has to guess the number for.</dd>
<dt>The Bridge</dt>
<dd>Another battle scene with a Gothon where the hero places the bomb.</dd>
<dt>Escape Pod</dt>
<dd>Where the hero escapes but only after guessing the right escape pod.</dd>
</dl>
<p>At this point I might draw out a map of these, maybe write more descriptions of each room, whatever comes to mind as I explore the problem.</p>
</div>
<div class="section" id="extract-key-concepts-and-research-them">
<h2>Extract Key Concepts and Research Them</h2>
<p>I now have enough information to extract some of the nouns and analyze their class hierarchy.  First I make a list of all the nouns:</p>
<ul class="simple">
<li>Alien</li>
<li>Player</li>
<li>Ship</li>
<li>Maze</li>
<li>Room</li>
<li>Scene</li>
<li>Gothon</li>
<li>Escape Pod</li>
<li>Planet</li>
<li>Map</li>
<li>Engine</li>
<li>Death</li>
<li>Central Corridor</li>
<li>Laser Weapon Armory</li>
<li>The Bridge</li>
</ul>
<p>I would also possibly go through all the verbs and see if they are anything that might be good function names, but I'll skip that for now.</p>
<p>At this point you might also research each of these concepts and anything you don't know right now.  For example, I might play a few of these types of games and make sure I know how they work.  I might research how ships are designed or how bombs work.  Maybe I'll research some technical issue like how to store the game's state in a database.  After I've done this research I might start over at step 1 based on new information I have and rewrite my description and extract new concepts.</p>
</div>
<div class="section" id="create-a-class-hierarchy-and-object-map-for-the-concepts">
<h2>Create a Class Hierarchy and Object Map for the Concepts</h2>
<p>Once I have that I turn it into a class hierarchy by asking &quot;What is similar to other things?&quot;  I also ask &quot;What is basically just another word for another thing?&quot;</p>
<p>Right away I see that &quot;Room&quot; and &quot;Scene&quot; are basically the same thing depending on how I want to do things.  I'm going to pick &quot;Scene&quot; for this game.  Then I see that all the specific rooms like &quot;Central Corridor&quot; are basically just Scenes.  I see also that Death is basically a Scene, which confirms my choice of &quot;Scene&quot; over &quot;Room&quot; since you can have a death scene, but a death room is kind of odd.  &quot;Maze&quot; and &quot;Map&quot; are basically the same so I'm going to go with &quot;Map&quot; since I used it more often.  I don't want to do a battle system so I'm going to ignore &quot;Alien&quot; and &quot;Player&quot; and save that for later.  The &quot;Planet&quot; could also just be another scene instead of something specific.</p>
<p>After all of that thought process I start to make a class hierarchy that looks like this in my text editor:</p>
<pre class="literal-block">
* Map
* Engine
* Scene
  * Death
  * Central Corridor
  * Laser Weapon Armory
  * The Bridge
  * Escape Pod
</pre>
<p>I would then go through and figure out what actions are needed on each thing based on verbs in the description.  For example, I know from the description I'm going to need a way to &quot;run&quot; the engine, &quot;get the next scene&quot; from the map, get the &quot;opening scene,&quot; and &quot;enter&quot; a scene.  I'll add those like this:</p>
<pre class="literal-block">
* Map
  - next_scene
  - opening_scene
* Engine
  - play
* Scene
  - enter
  * Death
  * Central Corridor
  * Laser Weapon Armory
  * The Bridge
  * Escape Pod
</pre>
<p>Notice how I just put <tt class="docutils literal"><span class="pre">-enter</span></tt> under <tt class="docutils literal">Scene</tt> since I know that all the scenes under it will inherit it and have to override it later.</p>
</div>
<div class="section" id="code-the-classes-and-a-test-to-run-them">
<h2>Code the Classes and a Test to Run Them</h2>
<p>Once I have this tree of classes and some of the functions I open up a source file in my editor and try to write the code for it.  Usually I'll just copy-paste the tree into the source file and then edit it into classes.  Here's a small example of how this might look at first, with a simple little test at the end of the file.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43_classes.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Scene</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-2"></a>
<a name="python--ex43_classes.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-4"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-5"></a>
<a name="python--ex43_classes.py-idio.html-6"></a>
<a name="python--ex43_classes.py-idio.html-7"></a><span class="k">class</span> <span class="nc">Engine</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-8"></a>
<a name="python--ex43_classes.py-idio.html-9"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">scene_map</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-10"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-11"></a>
<a name="python--ex43_classes.py-idio.html-12"></a>    <span class="k">def</span> <span class="nf">play</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-13"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-14"></a>
<a name="python--ex43_classes.py-idio.html-15"></a><span class="k">class</span> <span class="nc">Death</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-16"></a>
<a name="python--ex43_classes.py-idio.html-17"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-18"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-19"></a>
<a name="python--ex43_classes.py-idio.html-20"></a><span class="k">class</span> <span class="nc">CentralCorridor</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-21"></a>
<a name="python--ex43_classes.py-idio.html-22"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-23"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-24"></a>
<a name="python--ex43_classes.py-idio.html-25"></a><span class="k">class</span> <span class="nc">LaserWeaponArmory</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-26"></a>
<a name="python--ex43_classes.py-idio.html-27"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-28"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-29"></a>
<a name="python--ex43_classes.py-idio.html-30"></a><span class="k">class</span> <span class="nc">TheBridge</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-31"></a>
<a name="python--ex43_classes.py-idio.html-32"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-33"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-34"></a>
<a name="python--ex43_classes.py-idio.html-35"></a><span class="k">class</span> <span class="nc">EscapePod</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-36"></a>
<a name="python--ex43_classes.py-idio.html-37"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-38"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-39"></a>
<a name="python--ex43_classes.py-idio.html-40"></a>
<a name="python--ex43_classes.py-idio.html-41"></a><span class="k">class</span> <span class="nc">Map</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-42"></a>
<a name="python--ex43_classes.py-idio.html-43"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">start_scene</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-44"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-45"></a>
<a name="python--ex43_classes.py-idio.html-46"></a>    <span class="k">def</span> <span class="nf">next_scene</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">scene_name</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-47"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-48"></a>
<a name="python--ex43_classes.py-idio.html-49"></a>    <span class="k">def</span> <span class="nf">opening_scene</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43_classes.py-idio.html-50"></a>        <span class="k">pass</span>
<a name="python--ex43_classes.py-idio.html-51"></a>
<a name="python--ex43_classes.py-idio.html-52"></a>
<a name="python--ex43_classes.py-idio.html-53"></a><span class="n">a_map</span> <span class="o">=</span> <span class="n">Map</span><span class="p">(</span><span class="s1">&#39;central_corridor&#39;</span><span class="p">)</span>
<a name="python--ex43_classes.py-idio.html-54"></a><span class="n">a_game</span> <span class="o">=</span> <span class="n">Engine</span><span class="p">(</span><span class="n">a_map</span><span class="p">)</span>
<a name="python--ex43_classes.py-idio.html-55"></a><span class="n">a_game</span><span class="o">.</span><span class="n">play</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>In this file you can see that I simply replicated the hierarchy I wanted and then a little bit of code at the end to run it and see if it all works in this basic structure.  In the later sections of this exercise you'll fill in the rest of this code and make it work to match the description of the game.</p>
</div>
<div class="section" id="repeat-and-refine">
<h2>Repeat and Refine</h2>
<p>The last step in my little process isn't so much a step as it is a <tt class="docutils literal"><span class="pre">while-loop</span></tt>.  You don't ever do this as a one-pass operation.  Instead you go back over the whole process again and refine it based on information you've learned from later steps.  Sometimes I'll get to step 3 and realize that I need to work on 1 and 2 more, so I'll stop and go back and work on those.  Sometimes I'll get a flash of inspiration and jump to the end to code up the solution in my head while I have it there, but then I'll go back and do the previous steps to make sure I cover all the possibilities I have.</p>
<p>The other idea in this process is that it's not just something you do at one single level but something that you can do at every level when you run into a particular problem.  Let's say I don't know how to write the <tt class="docutils literal">Engine.play</tt> method yet.  I can stop and do this whole process on <em>just</em> that one function to figure out how to write it.</p>
</div>
</div>
<div class="section" id="top-down-vs-bottom-up">
<h1>Top Down vs. Bottom Up</h1>
<p>The process is typically labeled &quot;top down&quot; since it starts at the most abstract concepts (the top) and works its way down to actual implementation.  I want you to use this process I just described when analyzing problems in the book from now on, but you should know that there's another way to solve problems in programming that starts with code and goes &quot;up&quot; to the abstract concepts.  This other way is labeled &quot;bottom up.&quot;  Here are the general steps you follow to do this:</p>
<ol class="arabic simple">
<li>Take a small piece of the problem; hack on some code and get it to run barely.</li>
<li>Refine the code into something more formal with classes and automated tests.</li>
<li>Extract the key concepts you're using and try to find research for them.</li>
<li>Write a description of what's really going on.</li>
<li>Go back and refine the code, possibly throwing it out and starting over.</li>
<li>Repeat, moving on to some other piece of the problem.</li>
</ol>
<p>I find this process is better once you're more solid at programming and, are naturally thinking in code about problems.  This process is very good when you know small pieces of the overall puzzle, but maybe don't have enough information yet about the overall concept.  Breaking it down in little pieces and exploring with code then helps you slowly grind away at the problem until you've solved it.  However, remember that your solution will probably be meandering and weird, so that's why my version of this process involves going back and finding research then cleaning things up based on what you've learned.</p>
</div>
<div class="section" id="the-code-for-gothons-from-planet-percal-25">
<h1>The Code for &quot;Gothons from Planet Percal #25&quot;</h1>
<p>Stop! I'm going to show you my final solution to the above problem but I don't want you to just jump in and type this up.  I want <em>you</em> to take the rough skeleton code I did and try to make it work based on the description.  Once you have your solution then you can come back and see how I did it.</p>
<p>I'm going to break this final file <tt class="docutils literal">ex43.py</tt> down into sections and explain each one rather than dump all the code at once.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="kn">from</span> <span class="nn">sys</span> <span class="kn">import</span> <span class="nb">exit</span>
<a name="python--ex43.py-idio.html-2"></a><span class="kn">from</span> <span class="nn">random</span> <span class="kn">import</span> <span class="n">randint</span>
</pre></div>
</td></tr></table><p>This is just our basic imports for the game, nothing fancy really.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Scene</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-2"></a>
<a name="python--ex43.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-4"></a>        <span class="k">print</span> <span class="s2">&quot;This scene is not yet configured. Subclass it and implement enter().&quot;</span>
<a name="python--ex43.py-idio.html-5"></a>        <span class="nb">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>As you saw in the skeleton code, I have a base class for <tt class="docutils literal">Scene</tt> that will have the common things that all scenes do.  In this simple program they don't do much so this is more a demonstration of what you would do to make a base class.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Engine</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-2"></a>
<a name="python--ex43.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">scene_map</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-4"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">scene_map</span> <span class="o">=</span> <span class="n">scene_map</span>
<a name="python--ex43.py-idio.html-5"></a>
<a name="python--ex43.py-idio.html-6"></a>    <span class="k">def</span> <span class="nf">play</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-7"></a>        <span class="n">current_scene</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">scene_map</span><span class="o">.</span><span class="n">opening_scene</span><span class="p">()</span>
<a name="python--ex43.py-idio.html-8"></a>        <span class="n">last_scene</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">scene_map</span><span class="o">.</span><span class="n">next_scene</span><span class="p">(</span><span class="s1">&#39;finished&#39;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-9"></a>
<a name="python--ex43.py-idio.html-10"></a>        <span class="k">while</span> <span class="n">current_scene</span> <span class="o">!=</span> <span class="n">last_scene</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-11"></a>            <span class="n">next_scene_name</span> <span class="o">=</span> <span class="n">current_scene</span><span class="o">.</span><span class="n">enter</span><span class="p">()</span>
<a name="python--ex43.py-idio.html-12"></a>            <span class="n">current_scene</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">scene_map</span><span class="o">.</span><span class="n">next_scene</span><span class="p">(</span><span class="n">next_scene_name</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-13"></a>
<a name="python--ex43.py-idio.html-14"></a>        <span class="c1"># be sure to print out the last scene</span>
<a name="python--ex43.py-idio.html-15"></a>        <span class="n">current_scene</span><span class="o">.</span><span class="n">enter</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>I also have my <tt class="docutils literal">Engine</tt> class and you can see how I'm already using the methods for <tt class="docutils literal">Map.opening_scene</tt> and <tt class="docutils literal">Map.next_scene</tt>.  Because I've done a bit of planning I can just assume I'll write those and then use them before I've written the <tt class="docutils literal">Map</tt> class.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Death</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-2"></a>
<a name="python--ex43.py-idio.html-3"></a>    <span class="n">quips</span> <span class="o">=</span> <span class="p">[</span>
<a name="python--ex43.py-idio.html-4"></a>        <span class="s2">&quot;You died.  You kinda suck at this.&quot;</span><span class="p">,</span>
<a name="python--ex43.py-idio.html-5"></a>         <span class="s2">&quot;Your mom would be proud...if she were smarter.&quot;</span><span class="p">,</span>
<a name="python--ex43.py-idio.html-6"></a>         <span class="s2">&quot;Such a luser.&quot;</span><span class="p">,</span>
<a name="python--ex43.py-idio.html-7"></a>         <span class="s2">&quot;I have a small puppy that&#39;s better at this.&quot;</span>
<a name="python--ex43.py-idio.html-8"></a>    <span class="p">]</span>
<a name="python--ex43.py-idio.html-9"></a>
<a name="python--ex43.py-idio.html-10"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-11"></a>        <span class="k">print</span> <span class="n">Death</span><span class="o">.</span><span class="n">quips</span><span class="p">[</span><span class="n">randint</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">quips</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">)]</span>
<a name="python--ex43.py-idio.html-12"></a>        <span class="nb">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>My first scene is the odd scene named <tt class="docutils literal">Death</tt>, which shows you the simplest kind of scene you can write.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="k">class</span> <span class="nc">CentralCorridor</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-2"></a>
<a name="python--ex43.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-4"></a>        <span class="k">print</span> <span class="s2">&quot;The Gothons of Planet Percal #25 have invaded your ship and destroyed&quot;</span>
<a name="python--ex43.py-idio.html-5"></a>        <span class="k">print</span> <span class="s2">&quot;your entire crew.  You are the last surviving member and your last&quot;</span>
<a name="python--ex43.py-idio.html-6"></a>        <span class="k">print</span> <span class="s2">&quot;mission is to get the neutron destruct bomb from the Weapons Armory,&quot;</span>
<a name="python--ex43.py-idio.html-7"></a>        <span class="k">print</span> <span class="s2">&quot;put it in the bridge, and blow the ship up after getting into an &quot;</span>
<a name="python--ex43.py-idio.html-8"></a>        <span class="k">print</span> <span class="s2">&quot;escape pod.&quot;</span>
<a name="python--ex43.py-idio.html-9"></a>        <span class="k">print</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
<a name="python--ex43.py-idio.html-10"></a>        <span class="k">print</span> <span class="s2">&quot;You&#39;re running down the central corridor to the Weapons Armory when&quot;</span>
<a name="python--ex43.py-idio.html-11"></a>        <span class="k">print</span> <span class="s2">&quot;a Gothon jumps out, red scaly skin, dark grimy teeth, and evil clown costume&quot;</span>
<a name="python--ex43.py-idio.html-12"></a>        <span class="k">print</span> <span class="s2">&quot;flowing around his hate filled body.  He&#39;s blocking the door to the&quot;</span>
<a name="python--ex43.py-idio.html-13"></a>        <span class="k">print</span> <span class="s2">&quot;Armory and about to pull a weapon to blast you.&quot;</span>
<a name="python--ex43.py-idio.html-14"></a>
<a name="python--ex43.py-idio.html-15"></a>        <span class="n">action</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;&gt; &quot;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-16"></a>
<a name="python--ex43.py-idio.html-17"></a>        <span class="k">if</span> <span class="n">action</span> <span class="o">==</span> <span class="s2">&quot;shoot!&quot;</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-18"></a>            <span class="k">print</span> <span class="s2">&quot;Quick on the draw you yank out your blaster and fire it at the Gothon.&quot;</span>
<a name="python--ex43.py-idio.html-19"></a>            <span class="k">print</span> <span class="s2">&quot;His clown costume is flowing and moving around his body, which throws&quot;</span>
<a name="python--ex43.py-idio.html-20"></a>            <span class="k">print</span> <span class="s2">&quot;off your aim.  Your laser hits his costume but misses him entirely.  This&quot;</span>
<a name="python--ex43.py-idio.html-21"></a>            <span class="k">print</span> <span class="s2">&quot;completely ruins his brand new costume his mother bought him, which&quot;</span>
<a name="python--ex43.py-idio.html-22"></a>            <span class="k">print</span> <span class="s2">&quot;makes him fly into an insane rage and blast you repeatedly in the face until&quot;</span>
<a name="python--ex43.py-idio.html-23"></a>            <span class="k">print</span> <span class="s2">&quot;you are dead.  Then he eats you.&quot;</span>
<a name="python--ex43.py-idio.html-24"></a>            <span class="k">return</span> <span class="s1">&#39;death&#39;</span>
<a name="python--ex43.py-idio.html-25"></a>
<a name="python--ex43.py-idio.html-26"></a>        <span class="k">elif</span> <span class="n">action</span> <span class="o">==</span> <span class="s2">&quot;dodge!&quot;</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-27"></a>            <span class="k">print</span> <span class="s2">&quot;Like a world class boxer you dodge, weave, slip and slide right&quot;</span>
<a name="python--ex43.py-idio.html-28"></a>            <span class="k">print</span> <span class="s2">&quot;as the Gothon&#39;s blaster cranks a laser past your head.&quot;</span>
<a name="python--ex43.py-idio.html-29"></a>            <span class="k">print</span> <span class="s2">&quot;In the middle of your artful dodge your foot slips and you&quot;</span>
<a name="python--ex43.py-idio.html-30"></a>            <span class="k">print</span> <span class="s2">&quot;bang your head on the metal wall and pass out.&quot;</span>
<a name="python--ex43.py-idio.html-31"></a>            <span class="k">print</span> <span class="s2">&quot;You wake up shortly after only to die as the Gothon stomps on&quot;</span>
<a name="python--ex43.py-idio.html-32"></a>            <span class="k">print</span> <span class="s2">&quot;your head and eats you.&quot;</span>
<a name="python--ex43.py-idio.html-33"></a>            <span class="k">return</span> <span class="s1">&#39;death&#39;</span>
<a name="python--ex43.py-idio.html-34"></a>
<a name="python--ex43.py-idio.html-35"></a>        <span class="k">elif</span> <span class="n">action</span> <span class="o">==</span> <span class="s2">&quot;tell a joke&quot;</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-36"></a>            <span class="k">print</span> <span class="s2">&quot;Lucky for you they made you learn Gothon insults in the academy.&quot;</span>
<a name="python--ex43.py-idio.html-37"></a>            <span class="k">print</span> <span class="s2">&quot;You tell the one Gothon joke you know:&quot;</span>
<a name="python--ex43.py-idio.html-38"></a>            <span class="k">print</span> <span class="s2">&quot;Lbhe zbgure vf fb sng, jura fur fvgf nebhaq gur ubhfr, fur fvgf nebhaq gur ubhfr.&quot;</span>
<a name="python--ex43.py-idio.html-39"></a>            <span class="k">print</span> <span class="s2">&quot;The Gothon stops, tries not to laugh, then busts out laughing and can&#39;t move.&quot;</span>
<a name="python--ex43.py-idio.html-40"></a>            <span class="k">print</span> <span class="s2">&quot;While he&#39;s laughing you run up and shoot him square in the head&quot;</span>
<a name="python--ex43.py-idio.html-41"></a>            <span class="k">print</span> <span class="s2">&quot;putting him down, then jump through the Weapon Armory door.&quot;</span>
<a name="python--ex43.py-idio.html-42"></a>            <span class="k">return</span> <span class="s1">&#39;laser_weapon_armory&#39;</span>
<a name="python--ex43.py-idio.html-43"></a>
<a name="python--ex43.py-idio.html-44"></a>        <span class="k">else</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-45"></a>            <span class="k">print</span> <span class="s2">&quot;DOES NOT COMPUTE!&quot;</span>
<a name="python--ex43.py-idio.html-46"></a>            <span class="k">return</span> <span class="s1">&#39;central_corridor&#39;</span>
</pre></div>
</td></tr></table><p>After that I've created the <tt class="docutils literal">CentralCorridor</tt>, which is the start of the game.  I'm doing the scenes for the game before the <tt class="docutils literal">Map</tt> because I need to reference them later.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100
101
102
103
104
105</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="k">class</span> <span class="nc">LaserWeaponArmory</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-2"></a>
<a name="python--ex43.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-4"></a>        <span class="k">print</span> <span class="s2">&quot;You do a dive roll into the Weapon Armory, crouch and scan the room&quot;</span>
<a name="python--ex43.py-idio.html-5"></a>        <span class="k">print</span> <span class="s2">&quot;for more Gothons that might be hiding.  It&#39;s dead quiet, too quiet.&quot;</span>
<a name="python--ex43.py-idio.html-6"></a>        <span class="k">print</span> <span class="s2">&quot;You stand up and run to the far side of the room and find the&quot;</span>
<a name="python--ex43.py-idio.html-7"></a>        <span class="k">print</span> <span class="s2">&quot;neutron bomb in its container.  There&#39;s a keypad lock on the box&quot;</span>
<a name="python--ex43.py-idio.html-8"></a>        <span class="k">print</span> <span class="s2">&quot;and you need the code to get the bomb out.  If you get the code&quot;</span>
<a name="python--ex43.py-idio.html-9"></a>        <span class="k">print</span> <span class="s2">&quot;wrong 10 times then the lock closes forever and you can&#39;t&quot;</span>
<a name="python--ex43.py-idio.html-10"></a>        <span class="k">print</span> <span class="s2">&quot;get the bomb.  The code is 3 digits.&quot;</span>
<a name="python--ex43.py-idio.html-11"></a>        <span class="n">code</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">%d%d%d</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">9</span><span class="p">),</span> <span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">9</span><span class="p">),</span> <span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">9</span><span class="p">))</span>
<a name="python--ex43.py-idio.html-12"></a>        <span class="n">guess</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;[keypad]&gt; &quot;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-13"></a>        <span class="n">guesses</span> <span class="o">=</span> <span class="mi">0</span>
<a name="python--ex43.py-idio.html-14"></a>
<a name="python--ex43.py-idio.html-15"></a>        <span class="k">while</span> <span class="n">guess</span> <span class="o">!=</span> <span class="n">code</span> <span class="ow">and</span> <span class="n">guesses</span> <span class="o">&lt;</span> <span class="mi">10</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-16"></a>            <span class="k">print</span> <span class="s2">&quot;BZZZZEDDD!&quot;</span>
<a name="python--ex43.py-idio.html-17"></a>            <span class="n">guesses</span> <span class="o">+=</span> <span class="mi">1</span>
<a name="python--ex43.py-idio.html-18"></a>            <span class="n">guess</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;[keypad]&gt; &quot;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-19"></a>
<a name="python--ex43.py-idio.html-20"></a>        <span class="k">if</span> <span class="n">guess</span> <span class="o">==</span> <span class="n">code</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-21"></a>            <span class="k">print</span> <span class="s2">&quot;The container clicks open and the seal breaks, letting gas out.&quot;</span>
<a name="python--ex43.py-idio.html-22"></a>            <span class="k">print</span> <span class="s2">&quot;You grab the neutron bomb and run as fast as you can to the&quot;</span>
<a name="python--ex43.py-idio.html-23"></a>            <span class="k">print</span> <span class="s2">&quot;bridge where you must place it in the right spot.&quot;</span>
<a name="python--ex43.py-idio.html-24"></a>            <span class="k">return</span> <span class="s1">&#39;the_bridge&#39;</span>
<a name="python--ex43.py-idio.html-25"></a>        <span class="k">else</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-26"></a>            <span class="k">print</span> <span class="s2">&quot;The lock buzzes one last time and then you hear a sickening&quot;</span>
<a name="python--ex43.py-idio.html-27"></a>            <span class="k">print</span> <span class="s2">&quot;melting sound as the mechanism is fused together.&quot;</span>
<a name="python--ex43.py-idio.html-28"></a>            <span class="k">print</span> <span class="s2">&quot;You decide to sit there, and finally the Gothons blow up the&quot;</span>
<a name="python--ex43.py-idio.html-29"></a>            <span class="k">print</span> <span class="s2">&quot;ship from their ship and you die.&quot;</span>
<a name="python--ex43.py-idio.html-30"></a>            <span class="k">return</span> <span class="s1">&#39;death&#39;</span>
<a name="python--ex43.py-idio.html-31"></a>
<a name="python--ex43.py-idio.html-32"></a>
<a name="python--ex43.py-idio.html-33"></a>
<a name="python--ex43.py-idio.html-34"></a><span class="k">class</span> <span class="nc">TheBridge</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-35"></a>
<a name="python--ex43.py-idio.html-36"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-37"></a>        <span class="k">print</span> <span class="s2">&quot;You burst onto the Bridge with the netron destruct bomb&quot;</span>
<a name="python--ex43.py-idio.html-38"></a>        <span class="k">print</span> <span class="s2">&quot;under your arm and surprise 5 Gothons who are trying to&quot;</span>
<a name="python--ex43.py-idio.html-39"></a>        <span class="k">print</span> <span class="s2">&quot;take control of the ship.  Each of them has an even uglier&quot;</span>
<a name="python--ex43.py-idio.html-40"></a>        <span class="k">print</span> <span class="s2">&quot;clown costume than the last.  They haven&#39;t pulled their&quot;</span>
<a name="python--ex43.py-idio.html-41"></a>        <span class="k">print</span> <span class="s2">&quot;weapons out yet, as they see the active bomb under your&quot;</span>
<a name="python--ex43.py-idio.html-42"></a>        <span class="k">print</span> <span class="s2">&quot;arm and don&#39;t want to set it off.&quot;</span>
<a name="python--ex43.py-idio.html-43"></a>
<a name="python--ex43.py-idio.html-44"></a>        <span class="n">action</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;&gt; &quot;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-45"></a>
<a name="python--ex43.py-idio.html-46"></a>        <span class="k">if</span> <span class="n">action</span> <span class="o">==</span> <span class="s2">&quot;throw the bomb&quot;</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-47"></a>            <span class="k">print</span> <span class="s2">&quot;In a panic you throw the bomb at the group of Gothons&quot;</span>
<a name="python--ex43.py-idio.html-48"></a>            <span class="k">print</span> <span class="s2">&quot;and make a leap for the door.  Right as you drop it a&quot;</span>
<a name="python--ex43.py-idio.html-49"></a>            <span class="k">print</span> <span class="s2">&quot;Gothon shoots you right in the back killing you.&quot;</span>
<a name="python--ex43.py-idio.html-50"></a>            <span class="k">print</span> <span class="s2">&quot;As you die you see another Gothon frantically try to disarm&quot;</span>
<a name="python--ex43.py-idio.html-51"></a>            <span class="k">print</span> <span class="s2">&quot;the bomb. You die knowing they will probably blow up when&quot;</span>
<a name="python--ex43.py-idio.html-52"></a>            <span class="k">print</span> <span class="s2">&quot;it goes off.&quot;</span>
<a name="python--ex43.py-idio.html-53"></a>            <span class="k">return</span> <span class="s1">&#39;death&#39;</span>
<a name="python--ex43.py-idio.html-54"></a>
<a name="python--ex43.py-idio.html-55"></a>        <span class="k">elif</span> <span class="n">action</span> <span class="o">==</span> <span class="s2">&quot;slowly place the bomb&quot;</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-56"></a>            <span class="k">print</span> <span class="s2">&quot;You point your blaster at the bomb under your arm&quot;</span>
<a name="python--ex43.py-idio.html-57"></a>            <span class="k">print</span> <span class="s2">&quot;and the Gothons put their hands up and start to sweat.&quot;</span>
<a name="python--ex43.py-idio.html-58"></a>            <span class="k">print</span> <span class="s2">&quot;You inch backward to the door, open it, and then carefully&quot;</span>
<a name="python--ex43.py-idio.html-59"></a>            <span class="k">print</span> <span class="s2">&quot;place the bomb on the floor, pointing your blaster at it.&quot;</span>
<a name="python--ex43.py-idio.html-60"></a>            <span class="k">print</span> <span class="s2">&quot;You then jump back through the door, punch the close button&quot;</span>
<a name="python--ex43.py-idio.html-61"></a>            <span class="k">print</span> <span class="s2">&quot;and blast the lock so the Gothons can&#39;t get out.&quot;</span>
<a name="python--ex43.py-idio.html-62"></a>            <span class="k">print</span> <span class="s2">&quot;Now that the bomb is placed you run to the escape pod to&quot;</span>
<a name="python--ex43.py-idio.html-63"></a>            <span class="k">print</span> <span class="s2">&quot;get off this tin can.&quot;</span>
<a name="python--ex43.py-idio.html-64"></a>            <span class="k">return</span> <span class="s1">&#39;escape_pod&#39;</span>
<a name="python--ex43.py-idio.html-65"></a>        <span class="k">else</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-66"></a>            <span class="k">print</span> <span class="s2">&quot;DOES NOT COMPUTE!&quot;</span>
<a name="python--ex43.py-idio.html-67"></a>            <span class="k">return</span> <span class="s2">&quot;the_bridge&quot;</span>
<a name="python--ex43.py-idio.html-68"></a>
<a name="python--ex43.py-idio.html-69"></a>
<a name="python--ex43.py-idio.html-70"></a><span class="k">class</span> <span class="nc">EscapePod</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-71"></a>
<a name="python--ex43.py-idio.html-72"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-73"></a>        <span class="k">print</span> <span class="s2">&quot;You rush through the ship desperately trying to make it to&quot;</span>
<a name="python--ex43.py-idio.html-74"></a>        <span class="k">print</span> <span class="s2">&quot;the escape pod before the whole ship explodes.  It seems like&quot;</span>
<a name="python--ex43.py-idio.html-75"></a>        <span class="k">print</span> <span class="s2">&quot;hardly any Gothons are on the ship, so your run is clear of&quot;</span>
<a name="python--ex43.py-idio.html-76"></a>        <span class="k">print</span> <span class="s2">&quot;interference.  You get to the chamber with the escape pods, and&quot;</span>
<a name="python--ex43.py-idio.html-77"></a>        <span class="k">print</span> <span class="s2">&quot;now need to pick one to take.  Some of them could be damaged&quot;</span>
<a name="python--ex43.py-idio.html-78"></a>        <span class="k">print</span> <span class="s2">&quot;but you don&#39;t have time to look.  There&#39;s 5 pods, which one&quot;</span>
<a name="python--ex43.py-idio.html-79"></a>        <span class="k">print</span> <span class="s2">&quot;do you take?&quot;</span>
<a name="python--ex43.py-idio.html-80"></a>
<a name="python--ex43.py-idio.html-81"></a>        <span class="n">good_pod</span> <span class="o">=</span> <span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">5</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-82"></a>        <span class="n">guess</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;[pod #]&gt; &quot;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-83"></a>
<a name="python--ex43.py-idio.html-84"></a>
<a name="python--ex43.py-idio.html-85"></a>        <span class="k">if</span> <span class="nb">int</span><span class="p">(</span><span class="n">guess</span><span class="p">)</span> <span class="o">!=</span> <span class="n">good_pod</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-86"></a>            <span class="k">print</span> <span class="s2">&quot;You jump into pod </span><span class="si">%s</span><span class="s2"> and hit the eject button.&quot;</span> <span class="o">%</span> <span class="n">guess</span>
<a name="python--ex43.py-idio.html-87"></a>            <span class="k">print</span> <span class="s2">&quot;The pod escapes out into the void of space, then&quot;</span>
<a name="python--ex43.py-idio.html-88"></a>            <span class="k">print</span> <span class="s2">&quot;implodes as the hull ruptures, crushing your body&quot;</span>
<a name="python--ex43.py-idio.html-89"></a>            <span class="k">print</span> <span class="s2">&quot;into jam jelly.&quot;</span>
<a name="python--ex43.py-idio.html-90"></a>            <span class="k">return</span> <span class="s1">&#39;death&#39;</span>
<a name="python--ex43.py-idio.html-91"></a>        <span class="k">else</span><span class="p">:</span>
<a name="python--ex43.py-idio.html-92"></a>            <span class="k">print</span> <span class="s2">&quot;You jump into pod </span><span class="si">%s</span><span class="s2"> and hit the eject button.&quot;</span> <span class="o">%</span> <span class="n">guess</span>
<a name="python--ex43.py-idio.html-93"></a>            <span class="k">print</span> <span class="s2">&quot;The pod easily slides out into space heading to&quot;</span>
<a name="python--ex43.py-idio.html-94"></a>            <span class="k">print</span> <span class="s2">&quot;the planet below.  As it flies to the planet, you look&quot;</span>
<a name="python--ex43.py-idio.html-95"></a>            <span class="k">print</span> <span class="s2">&quot;back and see your ship implode then explode like a&quot;</span>
<a name="python--ex43.py-idio.html-96"></a>            <span class="k">print</span> <span class="s2">&quot;bright star, taking out the Gothon ship at the same&quot;</span>
<a name="python--ex43.py-idio.html-97"></a>            <span class="k">print</span> <span class="s2">&quot;time.  You won!&quot;</span>
<a name="python--ex43.py-idio.html-98"></a>
<a name="python--ex43.py-idio.html-99"></a>            <span class="k">return</span> <span class="s1">&#39;finished&#39;</span>
<a name="python--ex43.py-idio.html-100"></a>
<a name="python--ex43.py-idio.html-101"></a><span class="k">class</span> <span class="nc">Finished</span><span class="p">(</span><span class="n">Scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-102"></a>
<a name="python--ex43.py-idio.html-103"></a>    <span class="k">def</span> <span class="nf">enter</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-104"></a>        <span class="k">print</span> <span class="s2">&quot;You won! Good job.&quot;</span>
<a name="python--ex43.py-idio.html-105"></a>        <span class="k">return</span> <span class="s1">&#39;finished&#39;</span>
</pre></div>
</td></tr></table><p>This is the rest of the game's scenes, and since I know I need them and have thought about how they'll flow together I'm able to code them up directly.</p>
<p>Incidentally, I wouldn't just type all this code in.  Remember I said to try and build this incrementally, one little bit at a time.  I'm just showing you the final result.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Map</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-2"></a>
<a name="python--ex43.py-idio.html-3"></a>    <span class="n">scenes</span> <span class="o">=</span> <span class="p">{</span>
<a name="python--ex43.py-idio.html-4"></a>        <span class="s1">&#39;central_corridor&#39;</span><span class="p">:</span> <span class="n">CentralCorridor</span><span class="p">(),</span>
<a name="python--ex43.py-idio.html-5"></a>        <span class="s1">&#39;laser_weapon_armory&#39;</span><span class="p">:</span> <span class="n">LaserWeaponArmory</span><span class="p">(),</span>
<a name="python--ex43.py-idio.html-6"></a>        <span class="s1">&#39;the_bridge&#39;</span><span class="p">:</span> <span class="n">TheBridge</span><span class="p">(),</span>
<a name="python--ex43.py-idio.html-7"></a>        <span class="s1">&#39;escape_pod&#39;</span><span class="p">:</span> <span class="n">EscapePod</span><span class="p">(),</span>
<a name="python--ex43.py-idio.html-8"></a>        <span class="s1">&#39;death&#39;</span><span class="p">:</span> <span class="n">Death</span><span class="p">(),</span>
<a name="python--ex43.py-idio.html-9"></a>        <span class="s1">&#39;finished&#39;</span><span class="p">:</span> <span class="n">Finished</span><span class="p">(),</span>
<a name="python--ex43.py-idio.html-10"></a>    <span class="p">}</span>
<a name="python--ex43.py-idio.html-11"></a>
<a name="python--ex43.py-idio.html-12"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">start_scene</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-13"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">start_scene</span> <span class="o">=</span> <span class="n">start_scene</span>
<a name="python--ex43.py-idio.html-14"></a>
<a name="python--ex43.py-idio.html-15"></a>    <span class="k">def</span> <span class="nf">next_scene</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">scene_name</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-16"></a>        <span class="n">val</span> <span class="o">=</span> <span class="n">Map</span><span class="o">.</span><span class="n">scenes</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">scene_name</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-17"></a>        <span class="k">return</span> <span class="n">val</span>
<a name="python--ex43.py-idio.html-18"></a>
<a name="python--ex43.py-idio.html-19"></a>    <span class="k">def</span> <span class="nf">opening_scene</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex43.py-idio.html-20"></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">next_scene</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">start_scene</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>After that I have my <tt class="docutils literal">Map</tt> class, and you can see it is storing each scene by name in a dictionary, and then I refer to that dict with <tt class="docutils literal">Map.scenes</tt>.  This is also why the map comes after the scenes because the dictionary has to refer to the scenes so they have to exist.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex43.py-idio.html-1"></a><span class="n">a_map</span> <span class="o">=</span> <span class="n">Map</span><span class="p">(</span><span class="s1">&#39;central_corridor&#39;</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-2"></a><span class="n">a_game</span> <span class="o">=</span> <span class="n">Engine</span><span class="p">(</span><span class="n">a_map</span><span class="p">)</span>
<a name="python--ex43.py-idio.html-3"></a><span class="n">a_game</span><span class="o">.</span><span class="n">play</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>Finally I've got my code that runs the game by making a <tt class="docutils literal">Map</tt> then handing that map to an <tt class="docutils literal">Engine</tt> before calling <tt class="docutils literal">play</tt> to make the game work.</p>
</div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<p>Make sure you understand the game and that you tried to solve it yourself first.  One thing to do is if you're stumped, is cheat a little by reading my code, then continue trying to solve it yourself.</p>
<p>When I run my game it looks like this:</p>
<div class="highlight"><pre><span></span><a name="python--ex43.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex43.py
<a name="python--ex43.sh-idio-shint-pyg.html-2"></a><span class="go">The Gothons of Planet Percal #25 have invaded your ship and destroyed</span>
<a name="python--ex43.sh-idio-shint-pyg.html-3"></a><span class="go">your entire crew.  You are the last surviving member and your last</span>
<a name="python--ex43.sh-idio-shint-pyg.html-4"></a><span class="go">mission is to get the neutron destruct bomb from the Weapons Armory,</span>
<a name="python--ex43.sh-idio-shint-pyg.html-5"></a><span class="go">put it in the bridge, and blow the ship up after getting into an</span>
<a name="python--ex43.sh-idio-shint-pyg.html-6"></a><span class="go">escape pod.</span>
<a name="python--ex43.sh-idio-shint-pyg.html-7"></a>
<a name="python--ex43.sh-idio-shint-pyg.html-8"></a>
<a name="python--ex43.sh-idio-shint-pyg.html-9"></a><span class="go">You&#39;re running down the central corridor to the Weapons Armory when</span>
<a name="python--ex43.sh-idio-shint-pyg.html-10"></a><span class="go">a Gothon jumps out, red scaly skin, dark grimy teeth, and evil clown costume</span>
<a name="python--ex43.sh-idio-shint-pyg.html-11"></a><span class="go">flowing around his hate filled body.  He&#39;s blocking the door to the</span>
<a name="python--ex43.sh-idio-shint-pyg.html-12"></a><span class="go">Armory and about to pull a weapon to blast you.</span>
<a name="python--ex43.sh-idio-shint-pyg.html-13"></a><span class="gp">&gt;</span>  dodge!
<a name="python--ex43.sh-idio-shint-pyg.html-14"></a><span class="go">Like a world class boxer you dodge, weave, slip and slide right</span>
<a name="python--ex43.sh-idio-shint-pyg.html-15"></a><span class="go">as the Gothon&#39;s blaster cranks a laser past your head.</span>
<a name="python--ex43.sh-idio-shint-pyg.html-16"></a><span class="go">In the middle of your artful dodge your foot slips and you</span>
<a name="python--ex43.sh-idio-shint-pyg.html-17"></a><span class="go">bang your head on the metal wall and pass out.</span>
<a name="python--ex43.sh-idio-shint-pyg.html-18"></a><span class="go">You wake up shortly after only to die as the Gothon stomps on</span>
<a name="python--ex43.sh-idio-shint-pyg.html-19"></a><span class="go">your head and eats you.</span>
<a name="python--ex43.sh-idio-shint-pyg.html-20"></a><span class="go">Your mom would be proud...if she were smarter.</span>
</pre></div></div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Change it! Maybe you hate this game.  Could be too violent, you aren't into sci-fi.  Get the game working, then change it to what you like.  This is your computer, you make it do what you want.</li>
<li>I have a bug in this code. Why is the door lock guessing 11 times?</li>
<li>Explain how returning the next room works.</li>
<li>Add cheat codes to the game so you can get past the more difficult rooms.  I can do this with two words on one line.</li>
<li>Go back to my description and analysis, then try to build a small combat system for the hero and the various Gothons he encounters.</li>
<li>This is actually a small version of something called a &quot;finite state machine.&quot; Read about them.  They might not make sense but try anyway.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>Where can I find stories for my own games?</dt>
<dd>You can make them up, just like you would tell a story to a friend.  Or you can take simple scenes from a book or movie you like.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex43.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex43.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
